package model.fish.bad;

import model.ILambda;
import model.fish.display.ImageFishDisplay;
import sysModel.fish.AFish;

import java.awt.*;

/**
 * A fish that calls System.exit().
 *
 * @author Mathias Ricken
 */
public class ExitFish extends AFish {
    /**
     * Constructor.
     *
     * @param fishColor color of the fish
     */
    public ExitFish(Color fishColor) {
        super(fishColor, new ImageFishDisplay("smallfish.gif", 3.0 * Math.PI / 2.0));
    }

    /**
     * Move the fish.
     */
    protected void move() {
        tryMoveFwd(new ILambda() {
            public Object apply(Object param) {
                // call System.exit()
                System.exit(1);
                return null;
            }
        }, new ILambda() {
            public Object apply(Object param) {
                // move forward
                ((ILambda)param).apply(null);
                return null;
            }
        });
    }
}
