package model.fish.bad;

import model.ILambda;
import model.fish.display.ImageFishDisplay;
import sysModel.fish.Fish;
import sysModel.fish.IFishBehavior;

import java.awt.*;

/**
 * A fish that creates a heap overflow.
 *
 * @author Mathias Ricken
 */
public class HeapOverflowFish extends Fish {
    /**
     * Constructor.
     *
     * @param fishColor color of the fish
     */
    public HeapOverflowFish(Color fishColor) {
        super(fishColor, new ImageFishDisplay("smallfish.gif", 3.0 * Math.PI / 2.0), new IFishBehavior() {
            /**
             * Carry out movement behavior for the host fish.
             *
             * @param host fish to move.
             */
            public void move(Fish host) {
                while(true) {
                    // attempt to move forward
                    host.tryMoveFwd(new ILambda() {
                        public Object apply(Object param) {
                            // don't do anything
                            return null;
                        }
                    }, new ILambda() {
                        public Object apply(Object param) {
                            // don't do anything
                            return null;
                        }
                    });
                }
            }
        });
    }
}
