package model.fish.behavior;

import sysModel.fish.Fish;
import sysModel.fish.IFishBehavior;

/**
 * A rock "fish" that doesn't move.
 *
 * @author Mathias Ricken
 */
public class RockBehavior implements IFishBehavior {
    /**
     * Carry out movement behavior for the host fish.
     *
     * @param host fish to move.
     */
    public void move(Fish host) {
        // don't do anything
    }

    /**
     * Private singleton ctor.
     */
    private RockBehavior() {
    }

    /**
     * Singleton instance.
     */
    public static final RockBehavior Singleton = new RockBehavior();

}
